/**************************************************************************************
This file is part of SIMPSONS the 'wannabe' Game, a program developed by 
Dragos COJOCARU and Julien RAINOIRD.

    SIMPSONS the 'wannabe' Game is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    SIMPSONS the 'wannabe' Game is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details: http://www.gnu.org/licenses/.
    
**************************************************************************************/

class Simpsons {
  float x, y;
  float s;
  float v;
  float o;
  
  Simpsons(float x, float y, float s, float v, float o) {
    this.x = x;
    this.y = y;
    this.s = s;
    this.v = v;
    this.o = o;
  }
  
  Simpsons(float v) {
    this(random(width), random(height), 1, v, random(2*PI));
  }
  
  void dessinePersonnage() {
    scale(s);
    GenerateurTete gt;
    GenerateurYeux gy;
    GenerateurNez gn;
    GenerateurBouche gb;
    GenerateurOreilles go;
    
    pushMatrix();
    translate(x, y);
    gt = new GenerateurTete(10, 30);
    gy = new GenerateurYeux(25, 65);
    gn = new GenerateurNez(40, 75);
    gb = new GenerateurBouche(25, 110);
    go = new GenerateurOreilles(10, 90);

    gt.teteAleatoire();
    gy.yeuxAleatoires();
    gn.nezAleatoire();
    gb.boucheAleatoire();
    go.oreillesAleatoires();
    popMatrix();
  }
  
  //est-ce que la souris se trouve à l'intérieur du rectangle?
  boolean sourisDedans() {
    return (x < mouseX) && (mouseX < x + 100) && (y < mouseY) && (mouseY < y + 150);
  }
  
  //il faut bouger!
  void deplacer() {
    float vx = v * cos(o);
    float vy = v * sin(o);
   
    x = x + vx;
    //collision avec les extremités latitudinales
    if (x + 100 > width) 
      x = width - 100;
      vx = -vx;   
    if (x < 0)
      x = 0;
    
    y = y + vy;
    //collision avec les extremités longitudinales
    if (y + 150 > height)
      y = height - 150;
      vy = -vy;
    if (y < 0)
      y = 0;
  }
  
  //l'explosion marqué par un image significative
  void explosion() {
    PImage img;
    img = loadImage("Explosion.png");
    image(img, x - 100, y - 75);
  }
  
  boolean collision(Simpsons simpson) {
    return dist(simpson.x + 50, simpson.y + 75, this.x + 50, this.y + 75) < 2*sqrt(32500);
  }
  
  void changeDirection() {
    o = o + random(-PI/4, PI/4);
  }
 
}
