/**************************************************************************************
This file is part of SIMPSONS the 'wannabe' Game, a program developed by 
Dragos COJOCARU and Julien RAINOIRD.

    SIMPSONS the 'wannabe' Game is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    SIMPSONS the 'wannabe' Game is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details: http://www.gnu.org/licenses/.
    
**************************************************************************************/

/***************TETE***************/
class Tete {
 float x, y;

 Tete(float x, float y) {
  this.x = x;
  this.y = y;
 }
 
 void dessineToi() {
  fill(255, 255, 0);
  noStroke();
  rect(x, y, 80, 90);//visage
  arc(x + 40, y + 90, 80, 40, 0, PI);//menton
  beginShape();//cheveux
  vertex(x, y);
  vertex(x - 5, y - 15);
  vertex(x + 5, y - 5);
  vertex(x + 10, y - 20);
  vertex(x + 20, y - 10);
  vertex(x + 30, y - 25);
  vertex(x + 40, y - 10);
  vertex(x + 50, y - 25);
  vertex(x + 60, y - 10);
  vertex(x + 70, y - 20);
  vertex(x + 75, y - 5);
  vertex(x + 85, y - 15);
  vertex(x + 80, y);
  endShape(CLOSE);
 }
}

class Tete1 extends Tete {
  Tete1(float xInit, float yInit){
    super(xInit, yInit);
     }
 
 void dessineToi() {
  fill(255, 255, 0);
  noStroke();
  rect(x, y, 80, 90);//visage
  
  arc(x + 40, y, 80, 60, PI, 2*PI);//cheveux
  noFill();
  stroke(60);
  strokeWeight(1.5);
  arc(x + 42, y - 15, 40, 40, PI, 2*PI);
  arc(x + 38, y - 15, 40, 40, PI, 2*PI);
  
  noStroke();
  fill(222, 184, 135);
  ellipse(x + 40, y + 90, 80, 60);//barbe
 }
}

class Tete2 extends Tete {
  Tete2(float xInit, float yInit){
    super(xInit, yInit);
     }
  
  void dessineToi() {
    noStroke();
    fill(0, 0, 255);
    for (int i = 0; i < 9; i++) {
      ellipse(x, y + i*10, 20, 20);
      ellipse(x + 80, y + i*10, 20, 20);
    }

    fill(255, 255, 0);
    rect(x, y, 80, 90);
    arc(x + 40, y + 90, 80, 60, 0, PI);

    fill(0, 0, 255);
    for (int i = 0; i < 9; i++) {
      for (int j = 0; j < 3; j++) {
        ellipse(x + i*10, y - j*10, 20, 20);
      }
    }

    stroke(0);
    strokeWeight(1.5);
    for (int i = -1; i < 2; i++) {
      line(x + 15, y + 35, x + 15 + i*cos(PI/4) * 15, y + sin(PI/4) * 15);
      line(x + 65, y + 35, x + 65 + i*cos(PI/4) * 15, y + sin(PI/4) * 15);
    }
  }
}

class Tete3 extends Tete {
  Tete3(float xInit, float yInit) {
    super(xInit, yInit);
  }
  
  void dessineToi() {
    noStroke();
    fill(255, 255, 0);
    rect(x, y, 80, 90);
    arc(x + 40, y + 90, 80, 40, 0, PI);

    beginShape();
    vertex(x + 15, y + 90);
    vertex(x - 5, y + 80);
    vertex(x, y + 70);
    vertex(x - 10, y + 50);
    vertex(x - 5, y + 45);
    vertex(x - 10, y + 30);
    vertex(x - 5, y + 15);
    vertex(x - 10, y + 5);
    vertex(x, y);
    vertex(x - 5, y - 15);
    vertex(x + 5, y - 10);
    vertex(x + 10, y - 25);
    vertex(x + 25, y - 20);
    vertex(x + 30, y - 30);
    vertex(x + 40, y - 25);
    vertex(x + 50, y - 30);
    vertex(x + 55, y - 20);
    vertex(x + 70, y - 25);
    vertex(x + 75, y - 10);
    vertex(x + 85, y - 15);
    vertex(x + 80, y);
    vertex(x + 90, y + 5);
    vertex(x + 85, y + 15);
    vertex(x + 90, y + 30);
    vertex(x + 85, y + 45);
    vertex(x + 90, y + 50);
    vertex(x + 80, y + 70);
    vertex(x + 85, y + 80);
    vertex(x + 65, y + 90);
    endShape(CLOSE);
    
    stroke(0);
    strokeWeight(1.5);
    for (int i = -1; i < 2; i++) {
      line(x + 15, y + 35, x + 15 + i*cos(PI/4) * 15, y + sin(PI/4) * 15);
      line(x + 65, y + 35, x + 65 + i*cos(PI/4) * 15, y + sin(PI/4) * 15);
    }
  }
}

class GenerateurTete {
  float x, y;
  
  GenerateurTete(float x, float y) {
    this.x = x;
    this.y = y;
  }
  
  void teteAleatoire() {
    Tete[] tete = new Tete[4];
    tete[0] = new Tete(x, y);
    tete[1] = new Tete1(x, y);
    tete[2] = new Tete2(x, y);
    tete[3] = new Tete3(x, y);
    int k = int(random(4));
    tete[k].dessineToi();
  }
}

/***************YEUX***************/
class Yeux {
  float x, y;
  
  Yeux(float x, float y) {
    this.x = x;
    this.y = y;
  }
  
  void dessineToi() { 
    fill(255);
    smooth();
    noStroke();
    ellipse(x, y, 40, 40);
    ellipse(x + 50, y, 40, 40);
    
    stroke(random(256),random(256),random(256));
    strokeWeight(4);
    point(x, y);
    point(x + 50, y);
  }
}
  
class Yeux1 extends Yeux {
  Yeux1(float xInit, float yInit) {
    super(xInit, yInit);
  }
  
  void dessineToi() {
    fill(255);
    smooth();
    noStroke();
    ellipse(x, y, 40, 20);
    ellipse(x + 50, y, 40, 20);
    
    stroke(random(256),random(256),random(256));
    strokeWeight(4);
    point(x, y);
    point(x + 50, y);
  }
}

class Yeux2 extends Yeux {
  Yeux2(float xInit, float yInit) {
    super(xInit, yInit);
  }
  
  void dessineToi() {
    fill(255);
    smooth();
    noStroke();
    ellipse(x, y, 40, 40);
    ellipse(x + 50, y, 40, 40);
    
    stroke(random(256),random(256),random(256));
    strokeWeight(4);
    point(x, y);
    point(x + 50, y);
    
    fill(51, 0, 0, 100);
    stroke(51, 0, 0);
    strokeWeight(2);
    rect(x - 20, y - 15, 40, 30);
    rect(x + 30, y - 15, 40, 30);
    line(x + 20, y, x + 30, y);
  }
}

class GenerateurYeux {
  float x, y;
  
  GenerateurYeux(float x, float y) {
    this.x = x;
    this.y = y;
  }
  
  void yeuxAleatoires() {
    Yeux[] yeux = new Yeux[3];
    yeux[0] = new Yeux(x, y);
    yeux[1] = new Yeux1(x, y);
    yeux[2] = new Yeux2(x, y);
    yeux[int(random(3))].dessineToi();
  }
}

/***************NEZ***************/
class Nez {
  float x, y;
  
  Nez(float x, float y) {
    this.x = x;
    this.y = y;
  }
  
  void dessineToi() {
    fill(255, 204, 0);
    noStroke();
    ellipse(x, y, 20, 20);
  }
}

class Nez1 extends Nez {
  Nez1(float xInit, float yInit){
    super(xInit, yInit);
  }
  
   void dessineToi() {
   fill(255, 204, 0);
   noStroke();
   beginShape();
     vertex(x, y);
     vertex(x + 20, y);
     vertex(x + 10, y + 15);
   endShape(CLOSE);
   }
}

class Nez2 extends Nez {
  Nez2(float xInit, float yInit){
    super(xInit, yInit);
  }
 
  void dessineToi() {
   fill(255, 204, 0);
   noStroke();
   beginShape();
     vertex(x, y);
     vertex(x + 20, y);
     vertex(x + 10, y + 15);
   endShape(CLOSE);  
     
   beginShape();  
     vertex(x, y + 9);
     vertex(x + 20, y + 9);
     vertex(x + 10, y - 7);
   endShape(CLOSE); 
 }
}

class GenerateurNez {
  float x, y;
  
  GenerateurNez(float x, float y) {
    this.x = x;
    this.y = y;
  }
  
  void nezAleatoire() {
    Nez[] nez = new Nez[3];
    nez[0]= new Nez(x + 10,y + 5);
    nez[1]= new Nez1(x, y);
    nez[2]= new Nez2(x, y);
    nez[int(random(3))].dessineToi();
  }
}

/***************BOUCHE***************/
class Bouche {
  float x, y;
  
  Bouche(float x, float y) {
    this.x = x;
    this.y = y;
  }
  
  void dessineToi() {
    fill(204, 153, 51);
    noStroke();
    arc(x+25, y, 60, 3, PI, 2*PI);
    arc(x+25, y+14, 60, 3, 0, PI);
    
    stroke(0);
    strokeWeight(1);
    fill(255);
    for(int i = 0; i < 5; i++) {
      rect(x + i*10, y, 10, 13);
    }
  }
}

class Bouche1 extends Bouche {
  Bouche1 (float xInit, float yInit) {
    super(xInit, yInit);
  }
  
  void dessineToi() {
    noFill();
    stroke(0);
    strokeWeight(1);
    curve(x + 15, y - 100, x, y, x + 50, y, x + 35, y - 100);
  }
}
  
class Bouche2 extends Bouche {
  Bouche2 (float xInit, float yInit) {
    super(xInit, yInit);
  }
  
  void dessineToi() {
    noFill();
    stroke(0);
    strokeWeight(1);
    curve(x + 15, y + 100, x, y + 10, x + 50, y + 10, x + 35, y + 100);
  }
} 

class GenerateurBouche {
  float x, y;
  
  GenerateurBouche(float x, float y) {
    this.x = x;
    this.y = y;
  }
  
  void boucheAleatoire() {
    Bouche[] bouche = new Bouche[3];
    bouche[0] = new Bouche(x, y);
    bouche[1] = new Bouche1(x, y);
    bouche[2] = new Bouche2(x, y);
    bouche[int(random(3))].dessineToi();
  }
}

/***************OREILLES***************/
class Oreilles {
  float x, y;
  
  Oreilles(float x, float y) {
    this.x = x;
    this.y = y;
  }
  
  void dessineToi() {
    fill(255, 255, 0);
    
    noStroke();//arcade extérieure
    arc(x, y, 20, 20, PI/2, 3*PI/2);
    arc(x + 80, y, 20, 20, 3*PI/2, 5*PI/2);
    
    stroke(0);//arcade intérieure
    strokeWeight(0.6);
    arc(x, y, 10, 10, PI/2, 3*PI/2);
    arc(x + 80, y, 10, 10, 3*PI/2, 5*PI/2);
  }
}

class Oreilles1 extends Oreilles {
  Oreilles1(float xInit, float yInit) {
   super(xInit, yInit); 
  }
  
  void dessineToi() {
    fill(255, 255, 0);
    
    noStroke();//arcade extérieure
    triangle(x - 10, y, x, y - 10, x, y + 10);
    triangle(x + 90, y, x + 80, y - 10, x + 80, y + 10);
    
    stroke(0);//arcade intérieure
    strokeWeight(0.6);
    triangle(x - 5, y, x, y - 5, x, y + 5);
    triangle(x + 85, y, x + 80, y - 5, x + 80, y + 5);
  }
}

class Oreilles2 extends Oreilles {
  Oreilles2(float xInit, float yInit) {
   super(xInit, yInit); 
  }
  
  void dessineToi() {
    fill(255, 255, 0);
    
    noStroke();//arcade extérieure
    triangle(x - 10, y - 20, x, y - 10, x, y + 10);
    triangle(x + 90, y - 20, x + 80, y - 10, x + 80, y + 10);
    
    stroke(0);//arcade intérieure
    strokeWeight(0.6);
    triangle(x - 5, y - 10, x, y - 5, x, y + 5);
    triangle(x + 85, y - 10, x + 80, y - 5, x + 80, y + 5);
  }
}

class GenerateurOreilles {
  float x, y;
  
  GenerateurOreilles(float x, float y) {
    this.x = x;
    this.y = y;
  }
  
  void oreillesAleatoires() {
    Oreilles[] oreilles = new Oreilles[3];
    oreilles[0] = new Oreilles(x, y);
    oreilles[1] = new Oreilles1(x, y);
    oreilles[2] = new Oreilles2(x, y);
    oreilles[int(random(3))].dessineToi();
  }
}
