/**************************************************************************************
This file is part of SIMPSONS the 'wannabe' Game, a program developed by 
Dragos COJOCARU and Julien RAINOIRD.

    SIMPSONS the 'wannabe' Game is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    SIMPSONS the 'wannabe' Game is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details: http://www.gnu.org/licenses/.
    
**************************************************************************************/

ArrayList<Simpsons> simpsons;

void setup() {
  size(1000,500);
  background(0);
  frameRate(5);
  
  simpsons = new ArrayList<Simpsons>();
  
  for(int i = 0; i < 10; i++) {
    Simpsons simpson = new Simpsons(10);
    simpsons.add(simpson);
  }
}

void draw() {
  
  //collision entre les Simpsons
  for(int i = 0; i < simpsons.size(); i++) {
    Simpsons si = simpsons.get(i);
    for(int j = i + 1; j < simpsons.size(); j++) {
      Simpsons sj = simpsons.get(j);
      if (si.collision(sj)) {
        si.changeDirection();
        sj.changeDirection();
      }
    }
  }
  
  //deplacer les Simpsons
  for(int i = 0; i < simpsons.size(); i++) {
    simpsons.get(i).deplacer();
  }
    
  //dessiner les Simpsons
  background(0);
  for(int i = 0; i < simpsons.size(); i++) {
    simpsons.get(i).dessinePersonnage();
  }
  
  /*********THE GAME**********/
  PFont fs;
  fs = loadFont("LilyUPC-50.vlw");
  textFont(fs);
  
  int m = millis()/1000;//une seconde est équivalente à millis()/1000
  fill(255);
  text(m, 20, 30);

  if (m <= 10 && simpsons.size() == 0) {
    textAlign(CENTER);
    text("MISSION ACCOMPLISHED", width/2, height/2);
  }
  
  if (m > 10 && simpsons.size() != 0) {
    textAlign(CENTER);
    text("MISSION FAILED", width/2, height/2);
  }

}

void mousePressed() {
  
  //faire exploser le Simpson
  for(int i = 0; i < simpsons.size(); i++) {
    Simpsons simpson = simpsons.get(i);
    if(simpson.sourisDedans()) {
      simpsons.remove(i);
      simpson.explosion();
    }
  }
}
